/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Rekanan;
import com.portofolio.entity.vo.RekananId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository("rekananDao")
public interface RekananDao extends CrudRepository<Rekanan, RekananId> {

	@Cacheable("RekananDaofindOneBy")
	Rekanan findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and model.namaRekanan like %:namaRekanan% and model.kdJenisRekanan is null ")
	@Cacheable("RekananDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaRekanan") String namaRekanan, Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaRekanan like %:namaRekanan% and model.kdJenisRekanan=:kdJenisRekanan ")
	@Cacheable("RekananDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaRekanan") String namaRekanan, Pageable page, @Param("kdDepartemen") String kdDepartemen,
			@Param("kdJenisRekanan") Integer kdJenisRekanan);

	@Query(QListAll + " and model.id.kode = :kode")
	@Cacheable("RekananDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);
	
	@Query(" select new map(model.id.kdRekanan as kdRekanan,model.id.kdProfile as kdProfile, model.namaRekanan as namaRekanan) from Rekanan model where model.id.kdProfile=:kdProfile and model.statusEnabled=true")
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile);

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update RekananDetail m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdRekanan =:kdRekanan ")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile, @Param("kdRekanan") Integer kdRekanan);

	String QListAll = "select new map(model.id.kdRekanan as kdRekanan,model.id.kdProfile as kdProfile " + ", model.id.kode as kdRekanan "
			+ ", model.namaRekanan as namaRekanan " + ", model.reportDisplay as reportDisplay "
			+ ", model.contactPerson as contactPerson " + ", model.nPWP as nPWP " + ", model.noPKP as noPKP "
			+ ", model.kdAccount as kdAccount " + ", model.kdJenisRekanan as kdJenisRekanan "
			+ ", model.kdPegawai as kdPegawai " + ", model.kdRekananHead as kdRekananHead "
			+ ", rekananHead.namaRekanan as namaRekananHead " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.tglDaftar as tglDaftar " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.tglAwal as tglAwal " + ", model.tglAkhir as tglAkhir "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec "
			+ ", model.gambarLogo as gambarLogo "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from Rekanan model left join model.id id " + "left join model.rekananHead rekananHead "
			+ "left join model.departemen departemen where id.kdProfile=:kdProfile and departemen.id.kdProfile=id.kdProfile and model.kdDepartemen = :kdDepartemen ";

}
